/*
 * DJGPP&WATCOM WATEREFFECT
 * Original Source by Ska^d0d
 * Revised + Optimized + New water painting by KeN^d0d
 * Debugging + Revision help: Nail^d0d/Ska^d0d
 */

// Definisce il nuovo metodo di illuminazione NON ULTIMATO!!!
// #define _BUMPMAP_ON_
// #define _BUMP_LIGHTNESS_ 128 // Max. 255

/*
 * COMPILARE CON:
 * wcl386 /onahtx water.c
 * oppure:
 * gcc -O6 -fomit-frame-pointer water.c -o water.exe (pgcc 1.01/djgpp 2.1)
 * gcc -O3 -fomit-frame-pointer water.c -o water.exe (djgpp 2.1)
 *
 * TODO:
 * Portare in veza2 truecolor (ora si pu) (320x200x24),
 * Implementare allocazione dinamica, Ottimizzare (asm)
 * Migliorare algoritmo di calcwater?
 *
 * NOTA: Il watcom produce un codice + lento del pgcc. Controllare asm generato
 * ed integrare con inline asm dove necessario
 */

#include <time.h>
#include <math.h>
#include <stdio.h>
#define Pi__ 3.141592
#ifndef __DJGPP__
#include <i86.h>
#else
#include <sys\nearptr.h>
#include <dos.h>
#define min(a,b) (a<b?a:b)
#define max(a,b) (a>b?a:b)
#endif

// Buffer per l'immagine di sfondo 
 unsigned char imgbuffer[320*200];

// Buffer per la water
 int water[2][320*201];
 unsigned char *vga;

#ifdef _BUMPMAP_ON_
// Buffer per la lightmap
 unsigned char lmap[256*256];
#endif

 int *new;
 int *old;

void setmode(int mode)
 { union REGS r;
   r.w.ax=mode; 
   int386(0x10,&r,&r);
 }

void loadraw(int xwid, int ywid, void* buffer, char* file) 
 { FILE *bfile;

   bfile=fopen(file,"rb");
   fread(buffer,xwid,ywid,bfile);
   fclose(bfile);
 }

void setpal() 
 { int d;

   outp (0x3C8, 0);
   for  (d = 0; d < 256 ; d++) 
    { outp (0x3C9, d/8);
      outp (0x3C9, d/6);
      outp (0x3C9, d/4);
    }
 }

#ifdef _BUMPMAP_ON_
void setenvmap()
 { double nx,ny,nz;
   int x,y;

   for (y=0;y<256;y++)
      for (x=0;x<256;x++)
       { nx=(x-128)/128.0;
         ny=(y-128)/128.0;
         nz=1-sqrt(nx*nx+ny*ny);
         if (nz<0) nz=0;
         lmap[x+(y<<8)]=nz*_BUMP_LIGHTNESS_; 
       }
 }
#endif

void goccia(int x ,int y)
 { int i;
   i =x+320*y; 
   old[i]=180;
   old[i+1]=170;
   old[i-1]=170;
   old[i+320]=170;
   old[i-320]=170;
   old[i+321]=180;
   old[i-321]=180;
   old[i+319]=180;
   old[i-319]=180;
 } 

#ifndef _BUMPMAP_ON_
void plotwater() // Approssimato
 { int offset,c1; 

   for(offset=0;offset<63680;offset++)
    { c1=(new[offset]+
          new[offset+1]+
          new[offset+320])>>2;
      // Lo shr sopra controlla l'amount di distortion

      // Metodo 1 (distort+illuminaz.)
      vga[offset]=min(imgbuffer[min(offset+c1,64000)]+c1,255);
      // Metodo 2 (solo illuminaz. eliminare il calcolo di c1 sopra)
      // vga[offset]=min(imgbuffer[offset]+(c1<<2),255);
      // Metodo 3 (solo distort)
      // vga[offset]=imgbuffer[min(offset+c1,64000)];
    } 
 }
#else
void plotwater1(int lx,int ly) // Totalmente nuovo. Distort+illum. lightmap
 { int offset=0,x,y,c1,nx,ny; 

   lx+=128;
   ly+=128;

   for(y=0;y<199;y++)
      for(x=0;x<320;x++)
       { c1=new[offset];
         nx=new[offset+1]-c1;
         ny=new[offset+320]-c1;
         c1=imgbuffer[min(offset+nx+ny,64000)];
         nx+=(lx-x);
         ny+=(ly-y);
         if (nx>255 || nx<0) nx=255;
         if (ny>255 || ny<0) ny=255;
         vga[offset]=min(c1+lmap[nx+(ny<<8)],255);
         offset++;
       } 
 }
#endif

void dowater()
 { register int offset,c1;                      
   for(offset=1;offset<63358;offset++) // Loop hand-optimized :) Non so 
    { c1=(old[offset+321]+    // quanto sia conveniente in C, ma in
          old[offset+319]+    // asm si far cos...
          old[offset+640]+    // Non so se conviene convertirlo in asm!!!
          old[offset]+        // Il pgcc con le opzioni riportate all'inizio
          old[offset+639]+    // genera gi un codice quasi perfetto.
          old[offset+1]+      
          old[offset+641]+
          old[offset-1])>>2;
       c1-=(new[offset+320]+(new[offset+320]>>4)); // Lo shr controlla la
       new[offset+320]=max(c1,0);                  // densit della water
    }
 }

int main() 
 { int *tmp;
   clock_t start,end;
   int frames=0;
   double rad=0;

   // Inizzializziamo i buffer
   memset(water[0],0,64000*sizeof(int));
   memset(water[1],0,64000*sizeof(int));
   new=water[0]; old=water[1];

   // Mode 13
#ifndef __DJGPP__
   vga=(unsigned char*)(0xa0000);
#else
   __djgpp_nearptr_enable();
   vga=(unsigned char *)(0xa0000+__djgpp_conventional_base);
#endif
   setmode(0x13);
   setpal();

   // Carichiamo l'img di sfondo
   loadraw(320,200,imgbuffer,"aqua1.raw");

#ifdef _BUMPMAP_ON_
   // Calcoliamo l'envmap x la luce
   setenvmap();
#endif


   start=clock();
   while(!kbhit()) 
    { goccia(85*sin(2*rad)+160,50*cos(rad)+100);
      dowater();  // Calcoliamo la water

#ifndef _BUMPMAP_ON_
      plotwater(); // Disegniamo la water
#else
      plotwater1(320,0); // Disegniamo la water (xora la luce  statica)
#endif
      
      // Flippiamo old e new
      tmp=new; new=old; old=tmp;

      // frame counter
      frames++;

      rad+=0.05;                                     // Movimento della luce
      if (rad>2*Pi__) rad=0;                         // Onde evitare problemi...  
    }  
   end=clock();

   setmode(0x3);
   printf("FPS:%f",((double)frames)/(((double)(end-start))/CLOCKS_PER_SEC));
   return 0;
 }
